
/*
 *                        classe Soap2D_camera                        
 *                        --------------------                        
 *                                                                    
 * Cette classe spcifie la camra filmant la scne.                  
 * Une camra est reprsente par :                                   
 *                   - sa position (statique)                         
 *                   - son ratio (le format du film : 4/3, 16/9 ...)     
 *                                                                    
 * Une camra possde galement :                                      
 *                   - une liste de points qu'elle doit filmer,       
 *                     ces points tant reprsents par les angles    
 *                     verical et horizontal de la camra.           
 *                                                                    
 */ 


#include "Soap2D_camera.h"

//
// Constructeur
// ------------
// -> Soap2D_camera(float x, float y, float r)
//
// Construit une instance de camra,  partir de sa position et de son ratio
//
Soap2D_camera::Soap2D_camera(float x, float y, float r)
{
  position=new Soap_point2D(x,y);
  ratio=r;
}


//
// Destructeur
// -----------
// -> ~Soap2D_camera()
//
// Dtruit les pointeurs et les vecteurs.
//
Soap2D_camera::~Soap2D_camera()
{
  delete position;
  pt_camera.~vector();
}



//---------------------------------------------------


//
// -> AjoutPointCam(float th, float ph, float ouv_x, float ouv_y)
//
// Permet d'ajouter un point que devra filmer la camra. 
// Ce point est en fait reprsent par les angles (horizontal et vertical)
//  que devra prendre la camra afin de pointer sur le point qu'elle devra
//  filmer.
// On donne galement l'ouverture de la camra lorsqu'elle filmera en ce point.
// Les ouvertures verticales et horizontales doivent bien sr toujours respecter
//  le ratio de la camra.
//
void Soap2D_camera::AjoutPointCam(float th, float ph, float ouv_x, float ouv_y)
{
  Soap2D_pointcamera *pt=new Soap2D_pointcamera(th,ph,ouv_x,ouv_y);
  /*vector<Soap2D_pointcamera*> vtp;
  vtp=pt_camera;
  vtp.push_back(pt);
  cout<<vtp.at(0)->ouvX<<endl;*/
  //Soap2D_pointcamera *point=new Soap2D_pointcamera(th,ph,ouv_x,ouv_y);
  pt_camera.push_back(pt);
  //cout<<pt_camera.size()<<endl;
}
