#define SOAP2D_CAMERA_H


/*
 *                        classe Soap2D_camera                        
 *                        --------------------                        
 *                                                                    
 * Cette classe spcifie la camra filmant la scne.                  
 * Une camra est reprsente par :                                   
 *                   - sa position (statique)                         
 *                   - son ratio (le format du film : 4/3, 16/9 ...)  
 *                                                                    
 * Une camra possde galement :                                      
 *                   - une liste de points qu'elle doit filmer,       
 *                     ces points tant reprsents par les angles    
 *                     verical et horizontal de la camra.            
 *                                                                    
 */


#include <string>
#include <vector>
#include <iostream>

#ifndef SOAP2D_POINTCAMERA_H
#include "Soap2D_pointcamera.h"
#endif
#ifndef SOAP_POINT2D_H
#include "../SoapGeneral/Soap_point2D.h"
#endif
using namespace std;

class Soap2D_camera
{
 public :  

  /* ATTRIBUTS */
  
  Soap_point2D *position; // position en 2D de la camra
  float ratio;     // ratio du film
  
  vector<Soap2D_pointcamera*> pt_camera;  // liste des points  filmer

  /* METHODES */

  // constructeur, destructeur
  Soap2D_camera(float x, float y, float r);
  ~Soap2D_camera();

  // mthode permettant de rajouter un point  filmer  la camra
  void AjoutPointCam(float th, float ph, float ouv_x, float ouv_y);
};
