#define SOAP2D_PERSONNAGE_H

/*
	Classe Soap2D_personnage
	------------------------
	Cette classe reprsente les personnages de la scne en 2D.
	Un personnage est reprsent par :
		- son nom (identifiant unique)
		- sa couleur (triplet rvb)
		- la rayon de sa sphre englobante
		- la trajectoire qu'il va emprunter, reprsente par plusieurs point de passage
*/



#ifndef SOAP_COULEUR_H
#include "../SoapGeneral/Soap_couleur.h"
#endif
#ifndef SOAP_VARIABLES_H
#include "../SoapGeneral/Soap_variables.h"
#endif
#ifndef SOAP2D_POINTPASSAGE_H
#include "Soap2D_pointpassage.h"
#endif
#include <string>
#include <vector>
using namespace std;


class Soap2D_personnage
{

 /* ATTRIBUTS */	
 public:
  string nom;
  Soap_couleur * couleur;
  float rayon_sphere_englobante;

  vector<Soap2D_pointpassage *> pt_passage; // liste de ses points de passage

  /* METHODES */

  // constructeur, destructeur 
  Soap2D_personnage(string n, float Ray,float Vr, float Vg, float Vb);
  ~Soap2D_personnage();

  // mthode permattant d'ajouter un point de passage  la trajectoire
  void NouveauPointPassage(float x ,float y, float rayon, string allur, float agTete, float agCorps); 
};
