#define SOAP2D_POINTPASSAGE_H

/*
	Classe Soap2D_pointpassage
	--------------------------
	Cette classe permet de reprsenter un point de passage.
	Un point de passage est dfini par :
		- l'identifiant du personnage auquel il "appartient"
		- la position 2D (x et y) de ce point
		- le rayon du disque englobant
		- le type de dplacement (allure et angle de la tte et du corps)
*/


#include <string>
#include <iostream>
#ifndef SOAP_DEPLACEMENT_H	
#include "Soap_deplacement.h"
#endif
#ifndef SOAP_POINT2D_H	
#include "../SoapGeneral/Soap_point2D.h"
#endif
using namespace std;


class Soap2D_pointpassage
{

 /* ATTRIBUTS */

 public:
  string id_nom_perso;
  
  Soap_point2D *position;
  float rayon_disque; //disque englobant du personnage. 

  Soap_deplacement *type_deplacement;
  

  /* METHODES */

  // constructeur, destructeur
  Soap2D_pointpassage(string nom,float x,float y,float r);
  ~Soap2D_pointpassage();
  
  // mthode permettant de dfinir le dplacement pour  un point de passage
  void Deplacement_correspondant(int all, int tstop,float AnglTete, float AnglCorps);
 
};
