#define SOAP2D_POINTSYNCHRO_H

/*
	Classe Soap2D_pointsynchro
	--------------------------
	Cette classe permet de reprsenter les points de synchronisation entre 2 personnages.
	Un point de synchronisation est dfini entre 2 points de passages (1 point par personnage).
	Ce point de synchronisation exprime le fait que sur ces 2 points, les 2 personnages en question
      devront tre synchronis (donc arriver, ou partir en mme temps de ces points).
	Un point de synchronisation est dfini pr :
		- le personnage 1
		- le personnage 2
		- le point de passage du perso 1 concern par cette synchro
		- le point de passage du perso 2 concern par cette synchro
		- le type de synchro pour le perso 1
		- le type de synchro pour le perso 2
*/


#include <string>
#include <iostream>
using namespace std;

#ifndef SOAP2D_PERSONNAGE_H
#include "Soap2D_personnage.h"
#endif


class Soap2D_pointsynchro
{

 /* ATTRIBUTS */

 public:
  Soap2D_personnage *perso1;
  Soap2D_personnage *perso2;
  int pos_pt1;
  int pos_pt2;
  
  int type_synchro1; // synchro au dpart ou  l'arrive d'un point
  int type_synchro2;
  

  /* METHODES */

  // constructeur
  Soap2D_pointsynchro(Soap2D_personnage *np1, Soap2D_personnage *np2, int pp1, int pp2,int Tsync1, int Tsync2);
};
