#define SOAP2D_SYNCHROCAM_H

/*
	Classe Soap2D_synchrocam
	------------------------
	Cette classe permet de reprsenter le spoints de synchronisation de la camra.
	Un point de synchronisation s'effectue entre 1 point de passage d'un personnage
      et un point de passage de la camra. Ce point de synchronisation exprime le fait
      que la camra devra filmer le personnage passant sur le point de passage donn.
	Un point de synchronosation camra est dfini par :
		- la camra sur laquelle se fait cette synchro
		- le personnage sur lequel se fait cette synchro
		- le point de passage de la camra o se fait la synchro
		- le point de passage du personnage o se fait la synchro
		- le type de synchronisation pour le personnage (synchro  l'arrive ou au dpart du point)
*/

#include <string>
#include <iostream>
#ifndef SOAP2D_CAMERA_H
#include "Soap2D_camera.h"
#endif
#ifndef SOAP2D_PERSONNAGE_H
#include "Soap2D_personnage.h"
#endif
using namespace std;

class Soap2D_synchrocam
{

 /* ATTRIBUTS */

 public:
  Soap2D_camera *camera;
  Soap2D_personnage *perso;
  int pos_cam;
  int pos_perso;
  
  //int type_synchro_cam; // synchro au dpart ou  l'arrive d'un point
  int type_synchro_perso;
  
  /* METHODES */

  // constructeur
  Soap2D_synchrocam(Soap2D_camera *cam, Soap2D_personnage *per, int poscam, int pospers,int Tsyncp);
};

