#define INTERPOLATION_H

/*
 *                        classe Interpolation                         
 *                        -------------------                         
 *                                                                    
 * Cette classe abstraite permet de raliser les interpolations
 * soient linaires soient  l'aide de nurbs      
 * Interpolation est reprsente par :                                    
 *                   - la dimension
 *                   - le type (NURBS ou LINEAR)
 *                   - un tableau de points Cls 
 *                                                                    
 */ 
#include <math.h>
#include <vector>
#include <string>
#include <nurbs++/nurbs.h>

using namespace PLib ;//espace de nom rserv  la librairie nurbs++
using namespace std ;

class Interpolation
{
 
  protected : 
		/* ATTRIBUTS */
    int dimension;//la dimension
    int type;//NURBS ou LINEAR     
    Vector_Point3Df pointsCles;//tableau de point cls
 

 public :
 	const static int NURBS=0;
        const static int LINEAR=1;

		/*ACCESSEUR*/
        int getDimension(){return dimension;};
        
        int getType(){return type;};
        
        Vector_Point3Df getPointsCles(){return pointsCles;};
        
};

