#define INTERPOLATION_NURBS_H

/*
 *                        classe Interpolation_NURBS
 *                        -------------------                         
 *                                                                    
 * Cette classe permet de raliser les interpolations  l'aide de nurbs.
 * Elle hrite de Interpolation
 * Interpolation_NURBS est reprsente par :                                    
 *                   - la nurbs
 *                   - un tableau de correspondance entre lea parametre u et la distance sur la courbe
 *                                                                    
 */ 

#ifndef INTERPOLATION_H
#include "Interpolation.h"
#endif

class Interpolation_NURBS : public Interpolation {
      
     protected :
     	       /* ATTRIBUTS */
      NurbsCurvef courbe;//nurbs associe
      vector<double> tableau; //tableau de correspondance
      const static double pas = 0.05f;//pas de remplissage du tableau de correspondance

      
     public: 
	     
  // constructeurs
  Interpolation_NURBS();
             
  Interpolation_NURBS(Vector_Point3Df pCles);
  
  //distance linraire entre deux points
  double distancePoint(Point3Df pt1 , Point3Df pt2);
  
  //obtenir u en fonction de la distance curviligne
  double distance_vs_u(double dist);

  //obtenir le point3D correspondant  la distance curviligne
  Point3Df curveDistance(double dist);
      
  //obtenir la valeur de u suivant la distance
  double getValU(double d){return distance_vs_u(d);};
  
  //Obtenir le point3D suivant la distance
  Point3Df getPoint(double dist) {
    double u = distance_vs_u(dist);
    return Cp(u,courbe);
  }
  
  //obtenir la valeur du parametre u du point le plus proche
  double u_pointplusproche(Point3Df point);

  //distance curviligne suivant deux parametres u
  double distance_upt1vsupt2(double upt1, double upt2);
  
  //distance curviligne entre deux points
  double distance_pt1vspt2(Point3Df pt1, Point3Df pt2);

  //Obtenir la nurbs associe
  NurbsCurvef getCourbe(){return courbe;};

  //obtenir la valeur de l'ordonne minimum des pointsCles
  double min_ordonnee();
  
  //obtenir la valeur de l'ordonne maximum des pointsCles
  double max_ordonnee();
  
  //obtenir la valeur de l'abscisse minimum des pointsCles
  double min_abscisse();
  
  //obtenir la valeur de l'abscisse maximum des pointsCles
  double max_abscisse();
  
  //obtenir l'ordonne d'un point sur la nurbs suivant l'abscisse
  double obtient_ordonnee(double absc);

  //obtenir l'abscisse d'un point sur la nurbs suivant la cote
  double obtient_x_vs_z(double z);

  //obtenir l'ordonne d'un point sur la nurbs suivant la cote
  double obtient_y_vs_z(double z);

  //obtenir le parametre u suivant l'abscisse
  double obtient_u_vs_absisse(double absc);


      
};

