
/*
 *                        classe Soap3D_camera                        
 *                        --------------------                        
 *                                                                    
 * Cette classe spcifie la camra filmant la scne.                  
 * Une camra est reprsente par :                                   
 *                   - sa position (statique en 3D)                         
 *                   - son ratio (le format du film : 4/3, 16/9 ...)     
 *                                                                    
 * Une camra possde galement :                                      
 *                   - une liste de points qu'elle doit filmer,       
 *                     ces points tant reprsents par les angles    
 *                     verical et horizontal de la camra.           
 *                                                                    
 */ 

#include "Soap3D_camera.h"
//
// Constructeur
// ------------
// -> Soap3D_camera(Soap_point3D *p3d, float r)
//
// Construit une instance de camra,  partir de sa position et de son ratio
//
Soap3D_camera::Soap3D_camera(Soap_point3D *p3d,float r)
{
  position=new Soap_point3D(p3d);
  ratio=r;
}


//
// Destructeur
// -----------
// -> ~Soap3D_camera()
//
// Dtruit les pointeurs et les vecteurs.
//
Soap3D_camera::~ Soap3D_camera()
{
  pt_camera.~vector();
}



//---------------------------------------------------


//
// -> AjoutPointCam(float th, float ph, float ouv_x, float ouv_y)
//
// Permet d'ajouter un point que devra filmer la camra. 
// Ce point est en fait reprsent par les angles (horizontal et vertical)
//  que devra prendre la camra afin de pointer sur le point qu'elle devra
//  filmer.
// On donne galement l'ouverture de la camra lorsqu'elle filmera en ce point.
// Les ouvertures verticales et horizontales doivent bien sr toujours respecter
//  le ratio de la camra.
//
void Soap3D_camera::AjoutPointCam(float th, float ph, float ouv_x, float ouv_y)
{
  Soap3D_pointcamera *temp;
  temp=new Soap3D_pointcamera(th,ph,ouv_x,ouv_y);
  pt_camera.push_back(temp);
}


void Soap3D_camera::TempsCam(int num_point, float temps)
{
  pt_camera[num_point]->Temps(temps);
}
