#define SOAP3D_CAMERA_H


/*
 *                        classe Soap3D_camera                        
 *                        --------------------                        
 *                                                                    
 * Cette classe spcifie la camra filmant la scne.                  
 * Une camra est reprsente par :                                   
 *                   - sa position (statique, en 3D)                         
 *                   - son ratio (le format du film : 4/3, 16/9 ...)  
 *                                                                    
 * Une camra possde galement :                                      
 *                   - une liste de points qu'elle doit filmer,       
 *                     ces points tant reprsents par les angles    
 *                     verical et horizontal de la camra.            
 *                                                                    
 */


#include <string>
#include <vector>
using namespace std;

#ifndef SOAP3D_POINTCAMERA_H
#include "Soap3D_pointcamera.h"
#endif

#ifndef SOAP_POINT3D_H
#include "../SoapGeneral/Soap_point3D.h"
#endif

class Soap3D_camera
{
 public :  

  /* ATTRIBUTS */
  Soap_point3D *position; // position en 3D de la camra
  float posZ;	   // position en hauteur de la camra
  float ratio;     // ratio du film
  
  vector<Soap3D_pointcamera *> pt_camera;  // liste des points  filmer

  /* METHODES */

  // constructeur, destructeur
  Soap3D_camera(Soap_point3D *p3d,float r);
  ~Soap3D_camera();
  Soap3D_camera(){};
  // mthode permettant de rajouter un point  filmer  la camra
  void AjoutPointCam(float th, float ph, float ouv_x, float ouv_y);
  // mthode renseignant les temps des points  filmer
  void TempsCam(int num_point, float temps);
};
