#define SOAP3D_PERSONNAGE_H

/*
	Classe Soap3D_personnage
	------------------------
	Permet de dfinir les personnages de la scne (mais en 3D).
	Un personnage_3D est reprsent par :
		- son nom (identifiant unique)
		- sa couleur
		- un liste de ses points de passage
*/

#ifndef SOAP_COULEUR_H
#include "../SoapGeneral/Soap_couleur.h"
#endif
#ifndef SOAP3D_POINTPASSAGE_H
#include "Soap3D_pointpassage.h"
#endif
#ifndef SOAP_POINT3D_H
#include "../SoapGeneral/Soap_point3D.h"
#endif
#ifndef SOAP_DEPLACEMENT_H
#include "../Soap2D/Soap_deplacement.h"
#endif
#include <string>
#include <vector>
using namespace std;


class Soap3D_personnage
{

 /* ATTRIBUTS */

 public:
  string nom;
  Soap_couleur * couleur;
  float rayon_sphere_englobante;

  vector<Soap3D_pointpassage *> pt_passage;
  
  /* METHODES */

  // constructeur, destructeur
  Soap3D_personnage(string n, float ray,float Vr, float Vg, float Vb);
  ~Soap3D_personnage();
  // ajout d'un nouveau point de passage au trajet
  void NouveauPointPassage(Soap_point3D *pos, float agTete, float agCorps, int al, int tps); 
  // renseignement du temps d'arrive et de dpart pour un point de passage
  void TempsPoint(int num_point, float t_arriv ,float t_dep);
};
