#define SOAP3D_POINTPASSAGE_H

/*
	Classe Soap3D_pointpassage
	--------------------------
	Cette classe permet de reprsenter un point de passage 3D.
	Un point de passage 3D est reprsent par :
		- l'identifiant du personnage auquel il "appartient"
		- ses coordonnes 3D (x,y,z)
		- le temps d'arrive du personnage sur ce point
		- le temps de dpart du personnage sur ce point
		- l'angle de la tte du personnage au passage de ce point
		- l'angle du corps du personnage au passage de ce point
*/


#include <string>
#include <iostream>

#ifndef SOAP_POINT3D_H
#include "../SoapGeneral/Soap_point3D.h"
#endif
using namespace std;


class Soap3D_pointpassage
{

 /* ATTRIBUTS */

 public:
  string id_nom_perso;
  
  // coordonnes 3D
  Soap_point3D *position;
  
  int allure;
  float temps_arrivee;
  float temps_depart;
  float tempsattente;
  float distance;

  float angle_tete;
  float angle_corps;
    
  /* METHODES */

  // constructeur
  Soap3D_pointpassage(string nom,Soap_point3D *pos,float at,float ac, int all,int tpsattente);
  // renseignement du temps d'arrive et du temps de dpart sur le point 
  void Temps(float t_arriv ,float t_dep);
};
