#define SOAP3D_SCENE_H

/*
 *                        classe Soap3D_scene                         
 *                        -------------------                         
 *                                                                    
 * Cette classe code la scne que l'on veut reprsenter.              
 * Une scne est reprsente par :                                    
 *                   - son nom                                        
 *                   - sa taille (angle horizontal et vertical)       
 *                   - l'quation du plan (ax+by+cz=0)                
 *                                                                    
 * Une scne est compose :                                           
 *                   - d'une camra fixe (pied fixe)                  
 *                   - de plusieurs personnages   
 *                                                                    
 */ 

#include <string>	
#include <vector>
#include <iostream>
#ifndef SOAP_PLAN_H
#include "../SoapGeneral/Soap_plan.h"
#endif
#ifndef SOAP3D_PERSONNAGE_H
#include "Soap3D_personnage.h"
#endif
#ifndef SOAP_VARIABLE_H
#include "../SoapGeneral/Soap_variables.h"
#endif
#ifndef SOAP3D_CAMERA_H
#include "Soap3D_camera.h"
#endif
#ifndef SOAP2D_SCENE_H
#include "../Soap2D/Soap2D_scene.h"
#endif

using namespace std;

class Soap3D_scene
{
 public:
  
  /* ATTRIBUTS */
  string nom;                     // nom de la scne
  Soap_plan *eq_plan;             // quation du plan de la scne (de type ax+by+cz+d=0) 
  float ouverture_x;              // tendue en horizontal de la scne entire
  float ouverture_y;              // tendue en vertical de la scne entire
  Soap3D_camera *camera_scene;    // camra filmant la scne
  vector<Soap3D_personnage *> persos;        // liste des personnages prsents dans la scne

  /* METHODES */

  // constructeur, destructeur
  Soap3D_scene(Soap2D_scene *sc2D);
  ~Soap3D_scene();

  // ajout d'un personnage  la scne
  void AjoutPerso(string n, float ray,float Vr, float Vg, float Vb);
  // spcification de la camra
  void Camera(Soap_point3D *p3d,float ratio_cam);
  void affiche_scene();
};


