#include "Soap_contraintes.h"

Soap_contraintes::Soap_contraintes(string nomfic)
{
   nomFic_entree=nomfic;
   nomFic_entree += "_contraintes";
   nomFic_sortie= nomfic;
   nomFic_sortie += "_resultats";
}

Soap_contraintes::~Soap_contraintes()
{
}

void Soap_contraintes::ContrainteCamera(Soap2D_scene *sc2, Soap3D_scene *sc3)
{
   // on va ici remplir les champs pour le temps de passage pour chaque point de la camra
   // chaque point de passage de la camra tant sujet  une synchronisation avec un point de 
   // passage d'un personnage de la scne (on suppose que la camra ne filme que des personnages).
   Soap3D_personnage *perso;
   Soap2D_synchrocam *psync;
   int ptp; // point du personnage
   int ptc; // point de la camera
   int typSyncperso; // si la camra filme le personnage  l'arrive ou au dpart du point
   float temp_passage;
   int num=-1; // numro du personnage
   for (int i=0; i<sc2->pts_camsynchro.size(); i++)
   {
      // on regarde toutes les synchronisatons de la camra
      // pour chaque synchro, on rcupre les informations ncssaires
      psync=sc2->pts_camsynchro[i];
      string nper=psync->perso->nom;
      // on veut retrouver le numro du personnage, pour pouvoir pointer sur ce perso 3D
      for (int k=0;k<sc3->persos.size();k++)
      {
         if (sc3->persos[k]->nom==nper)
         num=k;
      }
      perso=sc3->persos[num];
      ptp=psync->pos_perso;
      ptc=psync->pos_cam;
      typSyncperso=psync->type_synchro_perso;
      // on cherche maintenant le temps du point de passage du personnage 
      if (typSyncperso==1) // synchro sur arrive
         temp_passage=perso->pt_passage[ptp]->temps_arrivee;
      if (typSyncperso==2) // synchro sur dpart
         temp_passage=perso->pt_passage[ptp]->temps_depart;
      // on peut maintenant renseigner le temps de passage de la camra (=temp_passage)
      sc3->camera_scene->TempsCam(ptc,temp_passage);
   }
}

// retourne si un point d'un personnage fait l'objet d'une synchronisation
int Soap_contraintes::ContrainteSur(int perso, int point, int typSync, Soap2D_scene *sc)
{
  Soap2D_pointsynchro *ps;
  int synchro_sur=0;
  for (int k=0;k<sc->pts_synchro.size();k++)
     {
       ps=sc->pts_synchro[k];
       if (( ps->perso1->nom==sc->persos[perso]->nom && 
             ps->pos_pt1==point &&
             ps->type_synchro1==typSync 
           ) 
           ||
           ( ps->perso2->nom==sc->persos[perso]->nom && 
             ps->pos_pt2==point &&
             ps->type_synchro2==typSync 
             ))
          synchro_sur=1;          
     }
   return(synchro_sur);
}

int Soap_contraintes::RetourneNumPers(Soap2D_scene *sc,int numPtSync,int pers)
{
  string nom="";
  int num=-1;
  if (pers==1)
    nom=sc->pts_synchro[numPtSync]->perso1->nom;
  if (pers==2)
    nom=sc->pts_synchro[numPtSync]->perso2->nom;
  for (int k=0;k<sc->persos.size();k++)
  {
    if (sc->persos[k]->nom==nom)
      num=k;
  }
  return(num);
}

void Soap_contraintes::ContraintesTemps(Soap2D_scene *sc2, Soap3D_scene *sc3)
{
    genereFicContraintes(sc2,sc3);
    genereFicResultats();
    renseigneTempsPersos(sc2,sc3);
    ContrainteCamera(sc2,sc3);
}


string Soap_contraintes::toString(int a)
{
   ostringstream ch;
   ch<<a;
   return ch.str();
}

void Soap_contraintes::renseigneTempsPersos(Soap2D_scene *scene,Soap3D_scene *sc3D)
{
   string test;
   ifstream fic_res;
   string valeur;
   float val_ar,val_dep; 
   fic_res.open(nomFic_sortie.c_str(), ios_base::in);
  for (int i=0; i<scene->persos.size();i++)
  {
      for (int j=0; j<scene->persos[i]->pt_passage.size();j++)
       {
           test="";
           while (!fic_res.eof() && test!="1") //on passe ce qui ne nous intresse pas
         	fic_res >> test;
           cout<<"test :"<<test<<endl;
           test="";
           val_ar=-1;
           // on est maintenant au niveau des valeurs de chaque variable
           while (test!="precision:" && val_ar==-1) 
           {
         	fic_res >> test;
                //cout<<"test2 : "<<test<<endl;
                string arriv="p"+toString(i);
                arriv+=toString(j);
                arriv+="_arriv";
                //cout<<"arriv : "<<arriv<<endl;
                if (test==arriv)
                {
                    fic_res >> test; // on passe le '=' ou le 'in'
                    fic_res >> valeur;
                   // cout<<"val"<<valeur<<endl;
                    if (valeur.substr(0,1)=="[")
		      val_ar=(float)atof(valeur.substr(1,valeur.size()-1).c_str());
                    else
                     val_ar=(float)atof(valeur.c_str()); // valeur d'arrive sur le point
                    //cout<<" val-ar "<<val_ar<<endl;
                }
           }
	   fic_res.seekg(0, ios::beg); // on retourne au dbut
	   test="";
           while (!fic_res.eof() && test!="1") //on passe ce qui ne nous intresse pas
	     fic_res >> test;
           //cout<<"test :"<<test<<endl;
           test="";
           val_dep=-1;
           // on est maintenant au niveau des valeurs de chaque variable

	   while (test!="precision:" && val_dep==-1) 
           {
         	fic_res >> test;
                string dep="p"+toString(i);
                dep+=toString(j);
                dep+="_dep";
                //cout<<"dep : "<<dep<<endl;
                if (test==dep)
                {
                    fic_res >> test; // on passe le '='
                    fic_res >> valeur;
                   //cout<<"val"<<valeur<<endl;
                    if (valeur.substr(0,1)=="[")
		      val_dep=(float)atof(valeur.substr(1,valeur.size()-1).c_str());
                    else
                     val_dep=(float)atof(valeur.c_str()); // valeur d'arrive sur le point
                   // cout<<" val-dep "<<val_dep<<endl;
                }
           }
           if (val_ar==-1) val_ar=0;
           if (val_dep==-1) val_dep=val_ar;
           cout<<"perso "<<i<<", point "<<j<<" a="<<val_ar<<" , d="<<val_dep<<endl;
           sc3D->persos[i]->TempsPoint(j,val_ar,val_dep);
           //fic_res.close();
           fic_res.seekg(0, ios::beg);
      }
  }

}



void Soap_contraintes::genereFicResultats()
{
   // on va passer le fichier de contraintes  realpaver
   // on va mettre les rsultats donns par realpaver dans le fichier rsultat.
   string commande=realpaver+nomFic_entree;
   commande+=" > ";
   commande+=nomFic_sortie;
   int err=system(commande.c_str());
   if (err==-1)
      cout<<"erreur de commande !!"<<endl;
   else
      cout<<"gnration ok"<<endl;
}


void Soap_contraintes::genereFicContraintes(Soap2D_scene *scene, Soap3D_scene *sc3)
{
  int i,j,k;
  Soap2D_pointsynchro *ps;
  //Soap_calcul *calc=new Soap_calcul();
  Soap_trajectoire *trajectoire;

  /* INITIALISATION DU FICHIER */

  // Ouverture du fichier
  ofstream fic_contraintes;
  fic_contraintes.open(nomFic_entree.c_str(), ios_base::out);

  // Teste si le fichier a pu etre ouvert ou non
  if(!fic_contraintes)
  {
    cout<<"Impossible d'ouvrir le fichier "<<nomFic_entree<<endl;
    exit(0);
  }

  
  /* CRITURE DANS LE FICHIER */


  // constantes
  // ----------
  // On met dans cette partie toutes la valeurs que l'on connait :
  //   - le temps de dpart des 1ers points de passage (pour chaque personnage)
  //     s'il n'y a pas de synchro dessus. Ce temps=0 si pas de synchro.
  //   - le temps entre 2 points de passages successifs
  
  fic_contraintes<<"Constants"<<endl;
  // on passe en revue tous les personnages de la scne
  for (int i=0;i<scene->persos.size();i++)
  {
     // si leur point de dpart fait l'objet d'une synchro, on ne peut pas le mettre  t=0  
     if (ContrainteSur(i,0,1,scene)==0)
     {
        fic_contraintes<<"   p"<<i<<"0_arriv=0"; // ex: p10_arriv=0
        if (scene->persos[i]->pt_passage.size()==1 && i==scene->persos.size()-1)
            fic_contraintes<<endl<<";"<<endl;
        else
            fic_contraintes<<","<<endl;
     }
     trajectoire = new Soap_trajectoire(sc3->persos[i]);
    // on passe en revue tous les points de passage du personnage
     for (int j=0;j<scene->persos[i]->pt_passage.size()-1;j++)
     {
        // on crit dans le fichier les distances entre chaque point et son suivant
        Soap_point3D *p1=sc3->persos[i]->pt_passage[j]->position;
        Soap_point3D *p2=sc3->persos[i]->pt_passage[j+1]->position;
        int all=scene->persos[i]->pt_passage[j]->type_deplacement->allure;
        int tpsstop=scene->persos[i]->pt_passage[j]->type_deplacement->tps_stop;
        float TpsEntre = trajectoire->temps_entre(j,j+1);
	cout<<TpsEntre<<endl;
	  //float TpsEntre=calc->CalculeTempsEntre(p1,p2,all,tpsstop);
        fic_contraintes<<"   p"<<i<<j<<"_p"<<i<<j+1<<"="<<TpsEntre;
        if (j==scene->persos[i]->pt_passage.size()-2 && i==scene->persos.size()-1)
            fic_contraintes<<endl<<";"<<endl;
        else
            fic_contraintes<<","<<endl;
     }
  }
  

  // variables (domaine des variables)
  // ---------------------------------
  // On met dans cette partie le domaine des variables
  // Dans notre cas, ce sont les temps d'arrive et de dpart de chaque point.
  // Donc, pour chaque valeur cherche, on sait que son domaine est compris entre
  // le temps d'arrive sur le 1er point, et l'infini (+)

  fic_contraintes<<endl<<"Variables"<<endl;
  // on passe en revue tous les personnages de la scne
  for (i=0;i<scene->persos.size();i++)
  {
     //si le temps d'arrive sur le 1er point fait l'objet d'une synchro, il faut le mettre en variable
     if (ContrainteSur(i,0,1,scene)==1)
     {
        fic_contraintes<<"   p"<<i<<"0_arriv in [0,+oo["; // ex: p10_dep in [0,+oo[
        if (scene->persos[i]->pt_passage.size()==1 && i==scene->persos.size()-1)
            fic_contraintes<<endl<<";"<<endl;
        else
            fic_contraintes<<","<<endl;
     }
     // si le personnage a plus d'un point de passage, on crit de domaine du temps de dpart
     if (scene->persos[i]->pt_passage.size()-1!=0)
        fic_contraintes<<"   p"<<i<<"0_dep in [0,+oo[,"<<endl; // ex: p10_dep in [p10_arriv,+oo[
     for (j=1;j<scene->persos[i]->pt_passage.size()-1;j++)
     {
        // pour tous les points de passage du personnage (sauf le premier et le dernier)
        // on crit le domaine du temps d'arrive et du temps de dpart de ces points
          fic_contraintes<<"   p"<<i<<j<<"_dep in [0,+oo[,"<<endl;
          fic_contraintes<<"   p"<<i<<j<<"_arriv in [0,+oo[,"<<endl;
     }
     // si le personnage a plus d'un point de passage, on crit le domaine du temps d'arrive sur son dernier
     if (scene->persos[i]->pt_passage.size()-1!=0)
     {
          fic_contraintes<<"   p"<<i<<scene->persos[i]->pt_passage.size()-1<<"_arriv in [0,+oo[";
          if (i==scene->persos.size()-1)
             fic_contraintes<<endl<<";"<<endl;
          else
             fic_contraintes<<","<<endl;      
     }
  }



  // contraintes
  // -----------
  // On crit ensuite toutes les contraintes entre les diffrents points.
  // Ce systme de contraintes devrait permettre de rsoudre les inconnues,
  // donc les temps d'arrive et de dpart de chaque point.

  fic_contraintes<<endl<<"Constraints"<<endl;
  // on exprime les points de synchronisation
  for (k=0;k<scene->pts_synchro.size();k++)
  {
     int nump1=RetourneNumPers(scene,k,1);
     int nump2=RetourneNumPers(scene,k,2);
     int p1=scene->pts_synchro[k]->pos_pt1;
     int p2=scene->pts_synchro[k]->pos_pt2;
     string typ1;
     string typ2;
     if (scene->pts_synchro[k]->type_synchro1==1)
       typ1="_arriv";
     if (scene->pts_synchro[k]->type_synchro1==2)
       typ1="_dep";
     if (scene->pts_synchro[k]->type_synchro2==1)
       typ2="_arriv";
     if (scene->pts_synchro[k]->type_synchro2==2)
       typ2="_dep";
     fic_contraintes<<"   p"<<nump1<<p1<<typ1<<"=p"<<nump2<<p2<<typ2<<","<<endl;
    
     // puis on exprime les relations entre les points avant et aprs, suivant les synchro
     if (typ1=="_arriv" && typ2=="_arriv")
     {
        if (p1==0 && p2==0)
        {
	  // s'il y a une contrainte entre 2 persos sur leur arrive sur le 1er point, alors 
          // on dcide que t_arriv=0 pour les deux
          fic_contraintes<<"   p"<<nump1<<p1<<"_arriv=0,"<<endl;
          fic_contraintes<<"   p"<<nump2<<p2<<"_arriv=0,"<<endl; 
        }
        if (p1==0 && !p2==0)
        {
          // s'il y a une synchro pour 1 des perso sur l'arrive de son premier point, alors il arrivera
          // lorque le 2e perso arrivera sur son point correspondant  la synchro  
          fic_contraintes<<"   p"<<nump1<<p1<<"_arriv=p"<<nump2<<p2-1<<"_arriv+p"<<nump2<<p2-1<<"_p"<<nump2<<p2<<","<<endl;
          fic_contraintes<<"   p"<<nump2<<p2-1<<"_dep=p"<<nump2<<p2-1<<"_arriv,"<<endl;
        }
       if (!p1==0 && p2==0)
        {
          // s'il y a une synchro pour 1 des perso sur l'arrive de son premier point, alors il arrivera
          // lorque le 2e perso arrivera sur son point correspondant  la synchro  
          fic_contraintes<<"   p"<<nump2<<p2<<"_arriv=p"<<nump1<<p1-1<<"_arriv+p"<<nump1<<p1-1<<"_p"<<nump1<<p1<<","<<endl;
          fic_contraintes<<"   p"<<nump1<<p1-1<<"_dep=p"<<nump1<<p1-1<<"_arriv,"<<endl;
        }
        if (!p1==0 && !p2==0)
        {
          fic_contraintes<<"   p"<<nump1<<p1-1<<"_dep=max(p"<<nump1<<p1-1<<"_arriv,p"<<nump2<<p2-1<<"_p"<<nump2<<p2<<"-p"<<nump1<<p1-1<<"_p"<<nump1<<p1<<"+p"<<nump2<<p2-1<<"_arriv),"<<endl;
          fic_contraintes<<"   p"<<nump2<<p2-1<<"_dep=max(p"<<nump2<<p2-1<<"_arriv,p"<<nump1<<p1-1<<"_p"<<nump1<<p1<<"-p"<<nump2<<p2-1<<"_p"<<nump2<<p2<<"+p"<<nump1<<p1-1<<"_arriv),"<<endl;
        }
     }
     if (typ1=="_dep" && typ2=="_dep")
     {
        fic_contraintes<<"   p"<<nump1<<p1<<"_dep=max(p"<<nump1<<p1<<"_arriv,p"<<nump2<<p2<<"_arriv),"<<endl;
        fic_contraintes<<"   p"<<nump2<<p2<<"_dep=max(p"<<nump2<<p2<<"_arriv,p"<<nump1<<p1<<"_arriv),"<<endl;
     }
     if (typ1=="_arriv" && typ2=="_dep")
     {
        if (p1==0)
        {
           fic_contraintes<<"   p"<<nump1<<p1<<"_arriv=p"<<nump2<<p2<<"_arriv,"<<endl;
           fic_contraintes<<"   p"<<nump2<<p2<<"_dep=p"<<nump2<<p2<<"_arriv,"<<endl;
        }
        else
        {
           fic_contraintes<<"   p"<<nump1<<p1-1<<"_dep=max(p"<<nump1<<p1-1<<"_arriv,p"<<nump2<<p2<<"_arriv-p"<<nump1<<p1-1<<"_p"<<nump1<<p1<<"+p"<<nump1<<p1-1<<"_arriv),"<<endl;
           fic_contraintes<<"   p"<<nump2<<p2<<"_dep=max(p"<<nump2<<p2<<"_arriv,p"<<nump1<<p1-1<<"_arriv+p"<<nump1<<p1-1<<"_p"<<nump1<<p1<<"),"<<endl;
        }
     }
     if (typ1=="_dep" && typ2=="_arriv")
     {
        if (p2==0)
        {
           fic_contraintes<<"   p"<<nump2<<p2<<"_arriv=p"<<nump1<<p1<<"_arriv,"<<endl;
           fic_contraintes<<"   p"<<nump1<<p1<<"_dep=p"<<nump1<<p1<<"_arriv,"<<endl;
        }
        else
        {
           fic_contraintes<<"   p"<<nump2<<p2-1<<"_dep=max(p"<<nump2<<p2-1<<"_arriv,p"<<nump1<<p1<<"_arriv-p"<<nump2<<p2-1<<"_p"<<nump2<<p2<<"+p"<<nump2<<p2-1<<"_arriv),"<<endl;
           fic_contraintes<<"   p"<<nump1<<p1<<"_dep=max(p"<<nump1<<p1<<"_arriv,p"<<nump2<<p2-1<<"_arriv+p"<<nump2<<p2-1<<"_p"<<nump2<<p2<<"),"<<endl;
        }
     }
 
  }
  // on passe en revue tous les personnages
  for (i=0;i<scene->persos.size();i++)
  {
     for (j=0;j<scene->persos[i]->pt_passage.size()-1;j++)
     {
        // on exprime tout d'abord que le temps de dpart d'un point est suprieur  l'arrive sur ce point
        fic_contraintes<<"   p"<<i<<j<<"_dep>=p"<<i<<j<<"_arriv,"<<endl;
        // puis on exprime le temps de passage entre 2 points conscutifs (pour un mme perso)
        fic_contraintes<<"   p"<<i<<j+1<<"_arriv=p"<<i<<j<<"_dep+p"<<i<<j<<"_p"<<i<<j+1<<","<<endl;
        // pour chaque point, s'il n'y a pas de synchro sur le dpart ou sur l'arrive sur le prochain point
        // alors temps_dep=temps_arriv
        if(ContrainteSur(i,j,2,scene)==0 && ContrainteSur(i,j+1,1,scene)==0)
           fic_contraintes<<"   p"<<i<<j<<"_dep=p"<<i<<j<<"_arriv,"<<endl;
        
     }
  }
  fic_contraintes<<"   0=0"<<endl<<";"<<endl;
  fic_contraintes.close();
}
