/***************************************************************************
      SOAP - Modlisation de scnes 3D  partir de spcifications en 2D
      -----------------------------------------------------------------

                                pov_camera.h
                                    --
                                description
                             -------------------
    Date          : Mardi 15 Mars 2005
    Auteur(s)     : BG
    Email         :
 ***************************************************************************/


#ifndef POV_CAMERA_H
#define POV_CAMERA_H

#include <string>
#include <iostream>
using namespace std;
#include "coord3d.h"
#include "outils.h"




/*
 * Classe POV_camera
 *
 * Permet de dfinir un objet camra utilisable sous Pov-Ray
 *
 */


class POV_camera {
private:
  float ratio;          // Ratio de la camera (1.33, 1.66, 1.85, 2.35, etc.)
  Coord3D * location;   // Position de la camera (Normalement situe en <0,0,0> mais utilise pour
                        // evolution future
  float phi, theta;
  float ouv_x, ouv_y;
public:
  POV_camera(float ratio_cam, Coord3D * position, float _phi, float _theta, float _ouv_x, float _ouv_y);
  POV_camera(float ratio_cam, float _phi, float _theta, float _ouv_x, float _ouv_y);
  POV_camera(float ratio_cam); 
  POV_camera();
  ~POV_camera();
  string POV_tostring();
};

#endif
