/***************************************************************************
      SOAP - Modlisation de scnes 3D  partir de spcifications en 2D
      -----------------------------------------------------------------

                                pov_generation.cpp
                                    --
                                description
                             -------------------
    Date          : Jeudi 26 Mai 2005
    Auteur(s)     : BG
    Email         :
 ***************************************************************************/

#include <iostream>
using namespace std;
#include "pov_generation.h"

POV_generation::POV_generation(Soap3D_scene *scene3d)
{
  scene = scene3d;
}


POV_generation::~POV_generation()
{

}

void POV_generation::generePOV()
{
  POV_fichier *fic;
  POV_ciel * sky;
  float y = -30.0;

  cout<<"Gnration des fichiers POV correspondants  la scne"<<endl;

  // On rcupre les coordonnes du plan
  float a_plan, b_plan, c_plan, d_plan; 
  a_plan = scene->eq_plan->a;
  b_plan = scene->eq_plan->b;
  c_plan = scene->eq_plan->c;
  d_plan = scene->eq_plan->d;
 
  // On rcupre la dure maximale de la scne
  // afin de pouvoir gnrer toutes les images
  float duree_max = -1;
  for(int cpt_perso = 0; cpt_perso<scene->persos.size(); cpt_perso++)
    {

	  cout<<cpt_perso<<"\t"<<scene->persos[cpt_perso]->pt_passage.size()<<endl;
	  if(scene->persos[cpt_perso]->pt_passage[scene->persos[cpt_perso]->pt_passage.size()-1]->temps_arrivee > duree_max)
	    duree_max = scene->persos[cpt_perso]->pt_passage[scene->persos[cpt_perso]->pt_passage.size()-1]->temps_arrivee;
    }
  cout<<"La dure de la scne est de : "<<duree_max<<endl;




  // On cr un lment Soap_interpolation afin de rcuprer, pour un temps t
  // la position exacte du personnage sur sa trajectoire (reprsente par une nurbs)
  Soap_interpolation *interp = new Soap_interpolation(scene->persos, scene->camera_scene);
  
  for(float i=0.0;i<=duree_max;i+=1.0)
    {
      string nomfic = scene->nom+RajouteZeros(3,(int)i);
      cout<<"Nom de la scne : "<<nomfic<<endl;
      fic = new POV_fichier(nomfic, "3.1", new POV_camera(2.35, 0, 0, 90, 0), sky, new POV_plan(a_plan,b_plan,c_plan,d_plan));
      fic->ajoute_lumiere(new POV_lumiere(new Coord3D(10.0,11.0,12.0), new POV_couleur(255,255,255)));
      for(int j = 0; j<scene->persos.size(); j++)
	{
	  interp->imprimeTrajectoire(scene->persos[j]->nom);
	  //interp->trajectoires[j]->vitesse.getCourbe().writePS("courbe_vitesse.ps",false,0,2);
	  interp->trajectoires[j]->vitesse.getCourbe().writePSp("courbe_vitesse.ps",interp->trajectoires[j]->vitesse.getPointsCles(),false,0,2);
	  //POV_personnage *perso = new POV_personnage(scene->persos[j]->nom,new POV_couleur((int)scene->persos[j]->couleur->r,(int)scene->persos[j]->couleur->g,(int)scene->persos[j]->couleur->b),0,0, new Coord3D(interp->position(scene->persos[j]->nom,i).x,interp->position(scene->persos[j]->nom,i).y,interp->position(scene->persos[j]->nom,i).z));
	  POV_personnage *perso = new POV_personnage(scene->persos[j]->nom,new POV_couleur((int)scene->persos[j]->couleur->r,(int)scene->persos[j]->couleur->g,(int)scene->persos[j]->couleur->b),0,0, new Coord3D(interp->position(scene->persos[j]->nom,i).x,-30,interp->position(scene->persos[j]->nom,i).z));
	  fic->ajoute_personnage(perso);
	  cout<<"\t t="<<i<<"\t x="<<interp->position(scene->persos[j]->nom,i).x<<"\t y="<<interp->position(scene->persos[j]->nom,i).y<<"\t z="<<interp->position(scene->persos[j]->nom,i).z<<endl;
	  
	}
      fic->POV_genere();
    }

  // Le nom du fichier sera le nom de la scne suivi de plusieurs chiffres permettant de garder l'ordre des
  // images pour la conversion en vido
  
      /*
 

 
  // On balaye la liste de tous les personnages et on affiche leur premier point de passage
  for(int i=0; i<scene->persos.size(); i++)
    {
      
    }
  fic->POV_genere();*/
}
