/***************************************************************************
      SOAP - Modlisation de scnes 3D  partir de spcifications en 2D
      -----------------------------------------------------------------

                            pov_personnage.cpp
                                    --
                                description
                             -------------------
    Date          : Jeudi 10 Mars 2005
    Auteur(s)     : BG
    Email         :
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include <string>
using namespace std;
 
#include "pov_personnage.h"
#include "pov_couleur.h"
#include "outils.h"

POV_personnage::POV_personnage()
{
  nom = "Bob";
  couleur = new POV_couleur(255,0,0);
  angle_tete = 0.0;
  angle_corps = 0.0; 
}

POV_personnage::POV_personnage(POV_personnage * p)
{
  nom = p->nom;
  couleur = p->couleur;
  angle_tete = p->angle_tete;
  angle_corps = p->angle_corps;
  position = new Coord3D(); 
}

POV_personnage::POV_personnage(string nom_perso, POV_couleur *color_perso, float angle_tete_perso, float angle_corps_perso, Coord3D * position_perso)
{
  nom = nom_perso;
  couleur = color_perso;
  angle_tete = angle_tete_perso;
  angle_corps = angle_corps_perso;
  position = position_perso;
}

POV_personnage::~POV_personnage()
{
  delete position; 
}

string POV_personnage::POV_tostring()
{
//  #declare bon1=dessine_bonhomme(Red,-90);
//  object { bon1 scale 0.5 translate <-30,-30,250> }

  string s = "#declare "+nom+"=dessine_bonhomme( rgb<"+EntierVersChaine(couleur->getR())+","+EntierVersChaine(couleur->getV())+","+EntierVersChaine(couleur->getB())+">/255,"+FloatVersChaine(angle_tete)+");";
  s += "object { "+nom+" scale 0.5 translate <"+FloatVersChaine(position->get_x())+","+FloatVersChaine(position->get_y())+","+FloatVersChaine(position->get_z())+"> }";

  return s;
}




