
/*
 *                        classe Soap_parser                       
 *                        -------------------                         
 *                                                                    
 * Cette classe permet d'intgrer les donnes du fichier xml fourni en entre dans la structrure Soap2D
 *
 * Soap_parser permet de dtecter certains types d'erreur comme une mauvaise hirarchie des balises xml
 *
 *                                                                    
 */ 

#include "Soap_parser.h"


// ->syntaxe_erreur(int nolig, string line)
//
// Affiche un message d'erreur si un conflit est dtecter et quitte le programme
//                 - le numro de la ligne du conflit
//                 - un message spcifique
//
void Soap_parser::syntaxe_erreur(int nolig, string line){
     cout<<"Erreur de syntaxe du fichier xml : "<<nolig<<" "<<line<<endl;
     exit(-1);
     }
     
//
// ->stof(string s)
//
// Convertit une chaine de caractre en sa valeur en rel (float)
//                 - la chaine de caractere
//

float Soap_parser::stof(string s){
      char* chaine = (char*)malloc(sizeof(chaine));
      for(int i=0;i<s.size();i++)chaine[i]=s[i];
      return atof(chaine);
      }
//
// ->stoi(string s)
//
// Convertit une chaine de caractre en sa valeur en entier (int)
//                 - la chaine de caractere
//
int Soap_parser::stoi(string s){
      char* chaine = (char*)malloc(sizeof(chaine));
      for(int i=0;i<s.size();i++)chaine[i]=s[i];
      return atoi(chaine);
      }
      
//
// ->decompose_couleur(char comp, string couleur)
//
// Decompose une chaine "R V B" (ou R,V,B sont compris entre 0 et 255) et renvoie
// uniquement la composante passe en parametre
//                 - le caractere de la composante voulue : r, v, b
//                 - la chaine "R V B"
//
string Soap_parser::decompose_couleur(char comp, string couleur){
       string rouge="",vert="",bleu="";

       for(int i=0;i<couleur.size();i++){

               if(couleur[i]==' '){
                  if(rouge==""){rouge=couleur.substr(0,i);}
                  else {if(vert==""){vert=couleur.substr(rouge.size()+1,i-rouge.size()-1);}}
               }
               }
      bleu=couleur.substr(rouge.size()+vert.size()+2,couleur.size()-rouge.size()-vert.size()-2);
       switch(comp){
          case 'r' : return rouge;break;
          case 'v' : return vert;break;
          case 'b' : return bleu;break;
	  default : return "";
         }
       } 
      
//
// ->init(istream& xfile)
//
// Parse le fichier xml
//                 - le fichier xml
// Retourne un pointeur sur Soap2D_scene contenant l'ensemble des
// informations du fichier xml
//

Soap2D_scene* Soap_parser::init(istream& xfile) { 
  int nolig=0;//numero de ligne
  int i=0,k,l;//indices de caractere
  int perso_courant=-1;//personnage courant
  string line,ouverte,param,valeur;
  Pile balises; //le nom de chacune des balises est stock pour l'analyse syntaxique et lexical du fichier
  Soap2D_scene *S;//pointeur sur la scene2D
  vector<string> variable;//stocke les variables de l'objet courant
  vector<string> attributs;//stocke les attributs de l'objet courant
  

while(getline(xfile, line)) {
i=0;            
//suppression des espaces et tabulations
while((line[i] == '\t')||(line[i] == ' ')) i++;


nolig++;
line = line.substr(i,line.size());//line ne contient plus de tabulations
switch (line[1]) {
       case '!' : if(line.substr(2,2)!="--") syntaxe_erreur(nolig,line);break;
                //sinon il s'agit d'un commentaire
       case '?' : break;//utilise pour les feuilles de style      
       case '/' : //balise fermante :
                if(balises.empty()) syntaxe_erreur(nolig,line+"\n ne correspond pas  la derniere balise ouvrante (pile vide)");
                ouverte = balises.top();

                if ((ouverte != line.substr(2,ouverte.size())) && (line.substr(2,2)!="pt")&&(line.substr(2,5)!="perso")) {                   
                            syntaxe_erreur(nolig,line+"\n ne correspond pas  la derniere balise ouvrante");

                    }
                    else {                         
                        balises.pop();//on dpile la pile de balises
			//si la derniere balise ouverte est plan
                         if(ouverte=="plan"){S=new Soap2D_scene(variable[0],//nom de la scene
                                                   stof(variable[3]),//coefficient a du plan
                                                   stof(variable[4]),//coefficient b du plan
                                                   stof(variable[5]),//coefficient c du plan
                                                   stof(variable[6]),//coefficient d du plan
                                                   stof(variable[1]),//ouverture sur les x
                                                   stof(variable[2]));//ouverture sur les y
						   variable.clear();};//reinitialisation de la liste variables
						   
			//si la derniere balise ouverte est pt
                         if(ouverte.substr(0,2)=="pt"){
	 
			 S->persos[perso_courant]->NouveauPointPassage(
                                                   stof(attributs[0]),//abscisse du point
                                                   stof(attributs[1]),//ordonne du point
                                                   stof(attributs[2]),//rayon englobant
                                                        variable[0],//allure chaine de caractere court, marche, stop x
                                                   stof(variable[1]),//angle tete
                                                   stof(variable[2]));//angle tete
						   variable.clear();//reinitialisation de la liste variables
						   attributs.clear();};//reinitialisation de la liste attributs
						   
			//si la derniere balise ouverte est pos
                         if(ouverte.substr(0,3)=="pos"){S->camera_scene->AjoutPointCam(
                                                   stof(attributs[0]),//theta
                                                   stof(attributs[1]),//phy
                                                   stof(variable[0]),//ouverture x
                                                   stof(variable[1]));//ouverture y
						   variable.clear();//reinitialisation de la liste variables
						   attributs.clear();};//reinitialisation de la liste attributs
                       }
                    break;      
                    
       default : 
               k=0,l=0;//indices de caractere
	       bool attribut=false;//si la line contient des attributs
               while(line[k]!='>'){if(line[k]=='=')attribut=true;k++;}//detection des attributs ventuels
               param=line.substr(1,k-1); //rcupration du nom de la balise
               if(line.size()==param.size()+3){//ligne de type "<couleur>"
                  if(!attribut)balises.push(param);//si line ne contient pas d'attribut, on se contente d'empiler param
		  else{//il s'agit d'une ligne comportant des attributs
		  
		      int m=0;//indice de caractere
                      bool nomparamok=false;//nom du parametre sauvegard ?
                      while(line[m]!='>'){
     			//on parcours chaque caractere de line
                        switch(line[m]){
                          case ' ' : 
			  	//si m=' ' alors la chaine avant m peut etre le nom du parametre
			  	if(!nomparamok){param=line.substr(1,m-1);
                                           nomparamok=true;
                                           if(param=="perso") perso_courant++;//incrmentation du perso courant
                                           balises.push(param);}break;//on empile le paramtre
                          case '"' : 
			  	//si m='"' alors la chaine de m  jusqu'au prochain '"' est un attribut
			  	int n=1;
				while(line[m+n]!='"')n++;attributs.push_back(line.substr(m+1,n-1));m+=n;break;//on empile les attributs                           
                         }                     
                         m++;                                         
                        }
		     //si le parametre est un personnage
                     if(param=="perso") { S->AjoutPerso(attributs[0],//nom du perso
                                                   stof(attributs[1]),//taille du perso
                                                   stof(decompose_couleur('r',attributs[2])),//couleur rouge
                                                   stof(decompose_couleur('v',attributs[2])),//couleur verte
                                                   stof(decompose_couleur('b',attributs[2]))//couleur bleue
                                                   );attributs.clear();};//rinitialisation de attributs
		     //si le parametre est la camra	   
                      if(param=="camera"){S->Camera(
                                                   stof(attributs[0]),//abscisse de la position fixe de la camra
                                                   stof(attributs[1]),//ordonne de la position fixe de la camra
                                                   stof(attributs[2]));//ratio fixe de la camra
                                                   attributs.clear();};//rinitialisation de attributs
		     //si le parametre est un point de synchros						   
		     if(param=="synpt") {balises.pop();S->AjoutPtSynchro(
                                                   attributs[0],//nom perso1
                                                   stoi(attributs[1]),//numero du point du perso 1
                                                   attributs[3],//nom perso2
                                                   stoi(attributs[4]),//numero du point du perso 2
                                                   attributs[2],//type de synchro du perso1
                                                   attributs[5]);//type de synchro du perso2
						   attributs.clear();};//rinitialisation de attributs
		      //si le parametre est un point de synchro camera						   
		     if(param=="syncampt") {balises.pop();S->AjoutSynchroCam(
                                                   attributs[0],//nom perso1
                                                   stoi(attributs[1]),//numero du point de la camera
                                                   stoi(attributs[2]),//numero du point du personnage
                                                   attributs[3]),//type d esynchronisation
                                                   attributs.clear();};//rinitialisation de attributs
		  }
                 }
                 else { //ligne de type <nom>soap</nom>
		 
                  while(line.substr(k+1,line.size())[l]!='<')l++;
                  valeur=line.substr(k+1,l);//rcupration de la valeur
                  if(line.substr(k+l+3,param.size())!=param){
                     syntaxe_erreur(nolig,line+"\n ne correspond pas  la derniere balise ouvrante");
                     }
                     else{
                     variable.push_back(valeur);//on empile la valeur
                     }       
                  }
                 }
              }
  return S; 
} 
 
