
/*
	Programme principal
	-------------------
	En paramtre d'entre, on a le nom du fichier xml  parser.
	Ce fichier xml contient les spcifications de la scne  modliser.
*/


#ifndef PARSER_H
#include "./SoapParser/Soap_parser.h"
#endif
#ifndef SOAP2D_SCENE_H
#include "./Soap2D/Soap2D_scene.h"
#endif
#ifndef SOAP3D_SCENE_H
#include "./Soap3D/Soap3D_scene.h"
#endif
#ifndef SOAP_CONTRAINTES_H
#include "./SoapContraintes/Soap_contraintes.h"
#endif
#ifndef POV_GENERATION_H
#include "./SoapPOV/pov_generation.h"
#endif
#include <math.h>



int main(int argc, char* argv[])
{
  /* cration de la scne 2D */

  Soap2D_scene *S; // on instancie la scne 2D
  Soap_parser *parser=new Soap_parser();
  ifstream xmlfile(argv[1]); // on rcupre le nom du fichier xml  parser
  S = parser->init(xmlfile); // on cre la scne correspondante
/*

  cout<<"-------------- 2D ---------------"<<endl;
  cout<<S->nom<<" , "<<S->eq_plan->a<<" , "<<S->eq_plan->b<<" , "<<S->eq_plan->c<<" , "<<S->eq_plan->d<<endl;
  cout<<S->persos[0]->nom<<endl; 
  cout<<S->persos[1]->nom<<endl;
  cout<<S->persos[0]->pt_passage[0]->type_deplacement->allure<<endl;
  cout<<S->persos[1]->pt_passage[0]->type_deplacement->allure<<endl;
  cout<<"nb persos 2 :"<<S->persos.size()<<endl;
  cout<<S->pts_synchro[0]->perso1->nom<<" <:synchro:> "<<S->pts_synchro[0]->perso2->nom<<endl;
  cout<<"ratio cam :"<<S->camera_scene->ratio<<endl;
  cout<<"point cam :"<<S->camera_scene->pt_camera[0]->ouvX<<endl;
*/

  /* cration de la scne 3D */
  Soap3D_scene *S3; // on instancie la scne 2D
  S3=new Soap3D_scene(S);
/*

  cout<<"-------------- 3D ---------------"<<endl;
  cout<<S3->nom<<" , "<<S3->eq_plan->a<<" , "<<S3->eq_plan->b<<" , "<<S3->eq_plan->c<<" , "<<S3->eq_plan->d<<endl;
  cout<<S3->persos[0]->nom<<endl; 
  cout<<S3->persos[1]->nom<<endl;
  cout<<S3->persos[0]->pt_passage[0]->allure<<endl;
  cout<<S3->persos[1]->pt_passage[0]->allure<<endl;
  cout<<"ratio cam :"<<S->camera_scene->ratio<<endl;

*/
  /* cration du fichier de contraintes */
  cout<<"-------------- contraintes ---------------"<<endl;
  Soap_contraintes *ficContr = new Soap_contraintes(S->nom);
  ficContr->ContraintesTemps(S,S3);
  cout<<"-------------- termin ---------------"<<endl;
/*
  cout<<S3->persos[0]->pt_passage[0]->position->z<<endl;
  cout<<S3->persos[0]->pt_passage[0]->temps_arrivee<<endl;
  cout<<S3->persos[0]->pt_passage[0]->temps_depart<<endl;

*/

  cout<<"Tan(0.61)="<<tan(0.61)<<endl;

// Affiche les points de tous les personnages

  for(int i=0; i<S3->persos.size();i++)
    {
      cout<<"Personnage "<<i<<endl;
      for(int j=0; j<S3->persos[i]->pt_passage.size(); j++)
	{
	  cout<<"   "<<S3->persos[i]->pt_passage[j]->position->x<<"   "<<S3->persos[i]->pt_passage[j]->position->y<<"   "<<S3->persos[i]->pt_passage[j]->position->z<<endl;
	}
    }


  POV_generation *sequence = new POV_generation(S3);
  sequence->generePOV();

}
