/*
	Programme principal
	-------------------
	En paramtre d'entre, on a le nom du fichier xml  parser.
	Ce fichier xml contient les spcifications de la scne  modliser.
*/

#ifndef SOAP_PARSER
#include "SoapParser/Soap_parser.h"
#endif

#ifndef SOAP2D_SCENE_H
#include "./Soap2D/Soap2D_scene.h"
#endif
#ifndef SOAP3D_SCENE_H
#include "./Soap3D/Soap3D_scene.h"
#endif
#ifndef SOAP_CONTRAINTES_H
#include "./SoapContraintes/Soap_contraintes.h"
#endif
#ifndef SOAP_INTERPOLATION_H
#include "./Soap3D/Soap_interpolation.h"
#endif


  
int main(int argc, char* argv[]) {

  /* cration de la scne 2D */

  Soap2D_scene *S; // on instancie la scne 2D
  Soap_parser *parser=new Soap_parser();
  ifstream xmlfile(argv[1]); // on rcupre le nom du fichier xml  parser
  S = parser->init(xmlfile); // on cre la scne correspondante

  /* Affichage scene 2D */
  cout<<"*******************AFFICHAGE STRUCTURE 2D****************\n";
  
  S->affiche_scene();

  /* test 2D */
  /*
  cout<<"-------------- 2D ---------------"<<endl;
  cout<<S->nom<<" , "<<S->eq_plan->a<<" , "<<S->eq_plan->b<<" , "<<S->eq_plan->c<<" , "<<S->eq_plan->d<<endl;
  cout<<S->persos[0]->nom<<endl; 
  cout<<S->persos[1]->nom<<endl;
  cout<<S->persos[0]->pt_passage[0]->type_deplacement->allure<<endl;
  cout<<S->persos[1]->pt_passage[0]->type_deplacement->allure<<endl;
  cout<<"nb persos 2 :"<<S->persos.size()<<endl;
  cout<<S->pts_synchro[0]->perso1->nom<<" <:synchro:> "<<S->pts_synchro[0]->perso2->nom<<endl;
  cout<<"ratio cam :"<<S->camera_scene->ratio<<endl;
  cout<<"point cam :"<<S->camera_scene->pt_camera[0]->ouvX<<endl;
*/


  /* cration de la scne 3D */
  Soap3D_scene *S3; // on instancie la scne 2D
  S3=new Soap3D_scene(S);

  
  for(int j=0;j<S3->persos.size();j++){
 	 for(int i=0;i<S3->persos[j]->pt_passage.size();i++) {
  
  	S3->persos[j]->pt_passage[i]->position->x = S->persos[j]->pt_passage[i]->position->x;
  	S3->persos[j]->pt_passage[i]->position->y = S->persos[j]->pt_passage[i]->position->y;
  	S3->persos[j]->pt_passage[i]->position->z = S->persos[j]->pt_passage[i]->rayon_disque;
  	}
  
  }
  
  

  
  
 // cout<<"*******************AFFICHAGE STRUCTURE 3D****************\n";
 //S3->affiche_scene();

/*
 // cration du fichier de contraintes 
  cout<<"-------------- contraintes ---------------"<<endl;
  Soap_contraintes *ficContr = new Soap_contraintes(S->nom);
  ficContr->ContraintesTemps(S,S3);
  cout<<"-------------- termin ---------------"<<endl;

  cout<<S3->persos[0]->pt_passage[0]->position->z<<endl;
  cout<<S3->persos[0]->pt_passage[0]->temps_arrivee<<endl;
  cout<<S3->persos[0]->pt_passage[0]->temps_depart<<endl;
  
  */
  

  Soap_interpolation interp(S3->persos,S3->camera_scene);
  
 

  
  cout<<"******test de temps_entre"<<endl;
  for(int i=1;i<5;i++)
  cout<<"**********************************\ntemps entre pt"<<i-1<<" et "<<i<<" "<<interp.temps_entre("jeannot",i-1,i)<<endl;
  
  
  interp.trajectoires[1]->perso->pt_passage[0]->temps_arrivee = 0;
  interp.trajectoires[1]->perso->pt_passage[0]->temps_depart = 0;
  interp.trajectoires[1]->perso->pt_passage[1]->temps_arrivee = 6.63291;
  interp.trajectoires[1]->perso->pt_passage[1]->temps_depart = 10.0;//On dit qu'il a un point de synchro
  interp.trajectoires[1]->perso->pt_passage[2]->temps_arrivee =12.42266;
  interp.trajectoires[1]->perso->pt_passage[2]->temps_depart = 12.42266;
  interp.trajectoires[1]->perso->pt_passage[3]->temps_arrivee = 22.42266;
  interp.trajectoires[1]->perso->pt_passage[3]->temps_depart = 22.42266;
  interp.trajectoires[1]->perso->pt_passage[4]->temps_arrivee = 26.76357;
  interp.trajectoires[1]->perso->pt_passage[4]->temps_depart = 26.76357;
  

  S3->camera_scene->pt_camera[0]->tps_film=0.0;
  S3->camera_scene->pt_camera[1]->tps_film=5.0;
  S3->camera_scene->pt_camera[2]->tps_film=8.0;
  S3->camera_scene->pt_camera[3]->tps_film=12.0;
  S3->camera_scene->pt_camera[4]->tps_film=15.0;
  S3->camera_scene->pt_camera[5]->tps_film=20.0;
  interp.creerInterpolation("pierrot");


  
    cout<<"****** PERSO : de position, angles"<<endl;
   
    for(float i=0.0;i<30.0;i+=0.5){
    Soap_point3D  poit3d = interp.position("pierrot",i);
    cout<<"au temps t="<<i<<" position -> "<<poit3d.x<<"\t"<<poit3d.y<<"\t"<<poit3d.z<<endl;
    cout<<"             angle_corps="<<interp.angle_corps("pierrot",i)<<endl;
    cout<<"             angle_tete="<<interp.angle_tete("pierrot",i)<<endl<<"******************\n\n";

  }
  

  
//Impression des Nurbs :


  //imprime la trajectoire du personnage au format postscript
  //interp.imprimeTrajectoire("pierrot");
  
  
  //interp.imprimeTrajectoire("pierrot");
  
  
  //imprime l'ensemble des nurbs des interpolations d'un personnage (vitesse et angles du corps et de la tete)
  //interp.imprimeInterpolationPerso("jeannot");
  
  //imprime l'ensemble des nurbs des interpolations de la realisation(angles de vue et zoom)
  //interp.imprimeInterpolationRealisation();


/*
  cout<<"***** CAMERA ******"<<endl;
  
  for(float tps=0.0; tps<20.1;tps+=0.5){
  cout<<"a temps ="<<tps<<endl;
  float theta = interp.camera_theta(tps);cout<<"\ttheta="<<theta<<endl;
  float phy= interp.camera_phy(tps);cout<<"\tphy="<<phy<<endl;
  float zoom = interp.camera_zoom(tps);cout<<"\tzoom="<<zoom<<endl<<endl;
  
  
  }
*/
  
}

